package xyz.mtfos.btdemo

import android.Manifest
import android.annotation.SuppressLint
import android.app.Activity
import android.content.pm.PackageManager
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.widget.Button
import android.widget.EditText
import xyz.mtfos.btdemo.objectTool.bind

/**
 * Created by jay on 2017/8/9.
 */
class MainActivity : Activity() {
    val intxt: EditText by bind(R.id.intxt)
    val btn: Button by bind(R.id.bt)
    val connectBtn: Button by bind(R.id.connect)
    val disconnectBtn: Button by bind(R.id.disconnect)
    var ble: BLECls? = null
    val uiHandler: Handler = Handler()
    var th: Thread? = null
    var thrun: Boolean = false
    var isInit: Boolean = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        btn.isEnabled = false
        connectBtn.isEnabled = true
        disconnectBtn.isEnabled = false

        ble = BLECls(this@MainActivity)

        var permissionCheck: Int = 0
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            permissionCheck += this@MainActivity.checkSelfPermission(android.Manifest.permission.ACCESS_COARSE_LOCATION)
            permissionCheck += this@MainActivity.checkSelfPermission(android.Manifest.permission.ACCESS_FINE_LOCATION)
            if (permissionCheck != 0) {
                requestPermissions(arrayOf(Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION), 111)
            }
        }

        btn.setOnClickListener {
            val txt: String = intxt.text.toString()
            ble?.sendLongData(txt.toByteArray())
        }

        connectBtn.setOnClickListener {
            scanConnect()
        }
        disconnectBtn.setOnClickListener {
            disconnect()
        }
    }

    override fun onRequestPermissionsResult(requestCode: Int, permissions: Array<out String>?, grantResults: IntArray?) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults)
    }

    override fun onStop() {
        super.onStop()
        disconnect()
    }

    fun scanConnect() {
        if (ble?.init()!!) {
            isInit = true
            ble?.startScan()
        }

        th = Thread(Runnable {
            thrun = true
            while (thrun) {
                System.out.println("state ===== " + ble?.mState)
                if (ble?.mState == ble?.CONNECTED) {
                    uiHandler.post {
                        btn.isEnabled = true
                        disconnectBtn.isEnabled = true
                        connectBtn.isEnabled = false
                    }
                    thrun = false
                    break
                }
                Thread.sleep(200)
            }
        })
        th?.start()
    }

    fun disconnect() {
        thrun = false
        if (ble?.isScanning!!) {
            ble?.stopScan()
        }
        if (ble?.mState == ble?.CONNECTED) {
            ble?.disconnect()
        }
        disconnectBtn.isEnabled = false
        connectBtn.isEnabled = true
        btn.isEnabled = false
        isInit = false
    }
}